# broadcast.py: Announcing descriptions.
# Copyright (C) 2013  Stephen Compall

# Julython-commit is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or (at
# your option) any later version.

# Julython-commit is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with Julython-commit.  If not, see <http://www.gnu.org/licenses/>.

import json
import sys
from urllib import urlencode
from urllib2 import Request as UrlRequest, urlopen

from zope.schema import URI

def explain(pushjson, target):
    URI(__name__='JSON target').validate(target)
    o = sys.stderr
    o.write("What I would write to %s:\n" % target)
    json.dump(pushjson, o, allow_nan=False, indent=4)
    o.write("\n")

# The magic POST parameter searched for.
magic_param = 'payload'

julython_magic_url = 'http://www.julython.org/api/v1/github'

def broadcast(pushjson, target):
    js = json.dumps(pushjson, allow_nan=False, separators=(',', ':'))
    req = UrlRequest(target, data = urlencode({magic_param: js}))
    f = urlopen(req)
    try:
        i = f.info().headers
        f.read()                # exhaust
        return i
    finally:
        f.close()

# broadcast.py ends here
